package cn.cecep.talroad.controller;

import cn.cecep.talroad.common.core.exception.CommonException;
import cn.cecep.talroad.common.core.utils.StringUtils;
import cn.cecep.talroad.common.core.utils.poi.ExcelUtil;
import cn.cecep.talroad.common.core.web.controller.BasesController;
import cn.cecep.talroad.common.core.web.domain.AjaxResults;
import cn.cecep.talroad.common.log.annotation.Log;
import cn.cecep.talroad.common.log.enums.BusinessType;
import cn.cecep.talroad.common.security.annotation.RequiresPermissions;
import cn.cecep.talroad.domain.SEnvWaterMonReal;
import cn.cecep.talroad.service.ISEnvWaterMonRealService;
import cn.cecep.talroad.vo.EChartsVO;
import cn.cecep.talroad.vo.SEnvWaterMonRealVo;
import cn.cecep.talroad.vo.query.SEnvWaterMonRealQuery;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.security.InvalidParameterException;
import java.util.Arrays;
import java.util.List;


/**
 * * 开发公司：中节能天融科技有限公司
 * 废水监测数据Controller 控制层
 *
 * @author szhpt
 * @date 2023-01-10*/
@Api(tags = "基本档案--废水监测数据")
@RestController
@RequestMapping("/sEnvWaterMonReal")
public class SEnvWaterMonRealController extends BasesController
{
    @Autowired
    private ISEnvWaterMonRealService sEnvWaterMonRealService;

    /**
     * 查询废水监测数据列表
     */
    @ApiOperation(value = "查询废水监测数据")
    @GetMapping("/list")
    public AjaxResults<IPage<SEnvWaterMonRealVo>> list(SEnvWaterMonRealQuery sEnvWaterMonReal)
    {
        if (StringUtils.isEmpty(sEnvWaterMonReal.getDataType())) {
            throw new InvalidParameterException("时间类型参数为空");
        }

        IPage<SEnvWaterMonRealVo> list = sEnvWaterMonRealService.selectSEnvWaterMonRealPage(sEnvWaterMonReal);
        return AjaxResults.success(list);
    }


    @ApiOperation(value = "查询废水监测曲线图数据")
    @GetMapping("/charData")
    public AjaxResults<EChartsVO> charData(SEnvWaterMonRealQuery sEnvWaterMonReal)
    {
        EChartsVO chartsVO = sEnvWaterMonRealService.getCharData(sEnvWaterMonReal);
        return AjaxResults.success(chartsVO);
    }

    @ApiOperation(value = "查询废水排口下所有监测点位的曲线图数据")
    @GetMapping("/charDataList")
    public AjaxResults<List<EChartsVO>> charDataList(SEnvWaterMonRealQuery sEnvWaterMonReal)
    {
        List<EChartsVO> chartsVO = sEnvWaterMonRealService.getCharDataList(sEnvWaterMonReal);
        return AjaxResults.success(chartsVO);
    }

    /**
     * 导出废水监测数据列表
     */
    @ApiOperation(value = "导出废水监测数据")
    @Log(title = "废水监测数据", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, @RequestBody SEnvWaterMonRealQuery sEnvWaterMonReal)
    {
        List<SEnvWaterMonRealVo> list = sEnvWaterMonRealService.selectSEnvWaterMonRealList(sEnvWaterMonReal);
        ExcelUtil<SEnvWaterMonRealVo> util = new ExcelUtil<SEnvWaterMonRealVo>(SEnvWaterMonRealVo.class);
        util.exportExcel(response, list, "废水监测数据数据");
    }

    /**
     * 获取废水监测数据详细信息
     */
    @ApiOperation(value = "获取废水监测数据详细信息")
    @PostMapping(value = "/{id}")
    public AjaxResults<SEnvWaterMonReal> getInfo(@PathVariable("id") Integer id) {
        return AjaxResults.success(sEnvWaterMonRealService.getById(id));
    }
    /**
     * 新增废水监测数据
     */
    @ApiOperation(value = "新增废水监测数据")
    @Log(title = "废水监测数据", businessType = BusinessType.INSERT)
    @PostMapping(value = "/add")
    public AjaxResults<Boolean> add(@RequestBody SEnvWaterMonReal sEnvWaterMonReal) {
        return toAjax(sEnvWaterMonRealService.save(sEnvWaterMonReal));
    }
    /**
     * 修改废水监测数据
     */
    @ApiOperation(value = "修改废水监测数据")
    @Log(title = "废水监测数据", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/edit")
    public AjaxResults<Boolean> edit(@RequestBody SEnvWaterMonRealVo sEnvWaterMonRealVo) {
        if(ObjectUtil.isEmpty(sEnvWaterMonRealVo)){
            throw new InvalidParameterException("参数为空");
        }
        if(ObjectUtil.isEmpty(sEnvWaterMonRealVo.getId())){
            throw new InvalidParameterException("参数id为空");
        }
        SEnvWaterMonReal sEnvWaterMonReal = sEnvWaterMonRealService.getById(sEnvWaterMonRealVo.getId());
        if(ObjectUtil.isEmpty(sEnvWaterMonReal)){
            throw new CommonException(StrUtil.format("根据id{}查询不到数据", sEnvWaterMonRealVo.getId()));
        }
        //赋值
        BeanUtil.copyProperties(sEnvWaterMonRealVo,sEnvWaterMonReal);
        return toAjax(sEnvWaterMonRealService.saveOrUpdate(sEnvWaterMonReal));
    }

    /**
     * 删除废水监测数据
     */
    @ApiOperation(value = "删除废水监测数据")
    @RequiresPermissions("talroad:real:remove")
    @Log(title = "废水监测数据", businessType = BusinessType.DELETE)
    @PostMapping("/{ids}")
    public AjaxResults<Boolean> remove(@PathVariable String[] ids) {
        return toAjax(sEnvWaterMonRealService.removeByIds(Arrays.asList(ids)));
    }

}
